\input tables.tex
%xdvi -paper a3 pseudoinstructions.dvi

%\special{papersize=11in,8.5in}
%\dimen0\hsize \hsize\vsize \vsize\dimen0

\special{papersize=297mm,210mm}\hsize297mm\advance\hsize-2in\vsize210mm\advance\vsize-2in

\def\section#1.{{\bf#1}\par}

\section Nomenklatura.

operand(t) ... operand of type t. Operand is either preg,mem, or lit\par
preg(t) ... pseudoregistr of type t \par
preglist ... list of pseudoregisters \par
mem(t) ... pamet typu t \par
lit(t) ... literal typu t \par
typ ... typovy suffix \par
decl ... link to declaration

Example:
t: typ, dest : preg(t), lft: preg(t), rt : preg(t)\par
ifuncall:i.2c.32:fp.32 r6,r9,[r1,r2,r3]

sub:i32 dest, lft, rt

 t | dest: preg(ptr), src: preg(t) | $MEM[*dest] \gets src$

\section Types.
\begintable
Integer | i.format.bits \cr
Unsigned int | u.format.bits \cr
Float | f.format.bits \cr
Pointer | p.format.bits \cr
Function pointer | fp.bits \cr
Label | label \cr
Condition codes | cc
\endtable

\section Formats.
\begintable
integer \cr
2c | 2 complement(typical)\cr
off | offset\cr
1c | 1 complement\cr
sm | sign+magnitude\cr
bcd | BCD\cr
pbcd | PBCD \cr
float \cr
ieee | IEC 60559:1989 previously IEC 559:1989, \nr |ANSI/IEEE 754--1985, ANSI/IEEE 854--1987 \nr | STANDARD mantisa + exp \cr
pointer \cr
so | segment - offset \cr
p | plain (offset only)
\endtable

\section Abbreviations.
f.ieee.N=fN \par
i.2c.N=iN \par
u.2c.N=uN \par
p.N=p \par

\section Pseudoregister structure.
\begintable
% int id | preg number \cr		//id urceno adresou
 Machine-type type | internal type \cr
% Decl *src | source declaration \cr  //zaniklo rozlisenim preg/mem
 PI *from | pseudoinstruction, which created preg \cr
% static int max | max-used value for preg 	//ditto
\endtable
\null\vfill

\begintable
mnemonics | full name | types | format | note -- functional description \cr
Arithmetical\cr
add | addition | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft + rt $\cr
sub | subtraction | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft - rt $\cr
mul | multiplication | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft * rt $\cr
div | division | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft / rt $ \cr
divrni | division round towards negative infinity | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft / rt $\cr
divrpi | division round towards positive infinity | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft / rt $\cr
divrz | division round towards zero | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft / rt $\cr
mod | modulo | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft \% rt $ result has the same sign as lft\cr
rem | reminder | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft \% rt $ result has the same sign as rt\cr
neg | negation | t | dest: preg(t), arg: preg(t) | $dest \gets \neg arg $\cr
gat | gation | t | dest: preg(t), arg: preg(t) | $dest \gets +arg $\cr
shl | left shift | t1, t2 | dest: preg(t1), arg: preg(t1), i: preg(t2) | $dest \gets arg << i $ logical (zero fill)\cr
shr | right shift | t1, t2 | dest: preg(t1), arg: preg(t1), i: preg(t2) | $dest \gets arg >> i $ logical (zero fill)\cr
sal | left arithm. shift | t1, t2 | dest: preg(t1), arg: preg(t1), i: preg(t2) | $dest \gets arg << i $ arithmetic (sign fill)\cr
sar | right arithm. shift | t1, t2 | dest: preg(t1), arg: preg(t1), i: preg(t2) | $dest \gets arg >> i $ arithmetic (sign fill)
\endtable
\null\vfill
\begintable
mnemonics | full name | types | format | note -- functional description \cr
Logical\cr
band | bitwise and | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft {\tt\char`\&} rt $\cr
bor | bitwise or | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft {\tt\char`\|} rt $\cr
bxor | bitwise xor | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft {\tt\char`\^} rt $\cr
bnot | bitwise not | t | dest: preg(t), arg: preg(t) | $dest \gets {\tt\char`\~} arg $\cr
land | logical and | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft {\tt\char`\&}{\tt\char`\&} rt $\cr
lor | logical or | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft {\tt\char`\|}{\tt\char`\|} rt $\cr
lxor | logical xor | t | dest: preg(t), lft: preg(t), rt: preg(t) | $dest \gets lft {\tt\char`\^\char`\^} rt $\cr
lnot | logical not | t | dest: preg(t), arg: preg(t) | $dest \gets {\tt\char`\!} arg $
\endtable
\null\vfill
\begintable
mnemonics | full name | types | format | note -- functional description \cr
Data Flow\cr
mov | move/assignment | t | dest: preg(t), src: preg (t) | $dest \gets src $ \cr
cmp | comparison | t | dest: preg(cc), c1: preg(t), c2: preg(t) | $dest \gets$ result of comparison \cr
cvt | conversion | t1, t2 | dest: preg(t1), src: preg(t2) |$dest \gets (t1) src $ \cr

ld | load | t | dest: preg(t), src: mem(t) | $dest \gets MEM[src]$\cr
lda| load address | t | dest: preg(t) src: mem(t) | $dest \gets \&src$\cr
ldi | load immediate | t | dest: preg(t), src: lit(t) | $dest \gets src$\cr
ldp | load via pointer | t, pt | dest: preg(t), src: preg(pt) | $dest \gets MEM[*src]$\cr
ldv | load volatile | t | dest: preg(t), src: mem(t) | $dest \gets MEM[src]$\cr
ldpv | load volatile via pointer | t, pt | dest: preg(t), src: preg(pt) | $dest \gets MEM[*src]$\cr
st | store | t | dest: mem(t), src: preg(t) | $MEM[dest] \gets src$ \cr
sti | store immediate | t | dest: mem(t), src: lit(t) | $MEM[dest] \gets src$ \cr
stp | store via pointer | pt, t | dest: preg(pt), src: preg(t) | $MEM[*dest] \gets src$\cr
stv | store volatile | t |  dest: mem(t), src: preg(t) | $MEM[dest] \gets src$ \cr
stiv | store immediate volatile | t | dest: mem(t), src: lit(t) | $MEM[dest] \gets src$ \cr
stpv | store volatile via pointer | pt, t | dest: preg(pt), src: preg(t) | $MEM[*dest] \gets src$
\endtable
\null\vfill
\begintable
mnemonics | full name | types | format | note -- functional description \cr
Control flow\cr
call | function call | rt | rv: mem(rt), this: mem, f:decl, args: memlist | $ f(args) $ \cr
icall | indirect funcall | rt, fpt | rv: mem(rt), this mem, f: preg(fpt), args: memlist | $ (*f)(); $\cr
callv | funcall, void return (NPOD) | | this: mem, f:decl, args: memlist| $ f(args) $ \cr
icallv | indirect funcall, void return | fpt | this: mem, f: preg(fpt), args: memlist| $ (*f)(args) $ \cr

ba | branch always (jump) || dest: label | goto $dest$\cr
bn | branch never (nop) || dest: label | no operation\cr
bm | branch multiple (switch jump) | t | val:preg(t), lvl label-val-list(t) | j $lvl [val]$ \cr
bg | branch if greater || cond: preg(cc), dest: label | if ($cond\equiv gt$) goto $dest$\cr
bl | branch if less || cond: preg(cc), dest: label | if ($cond\equiv lt$) goto $dest$ \cr
be | branch if equal || cond: preg(cc), dest: label | if ($cond\equiv eq$) goto $dest$\cr
bng | branch if not greater || cond: preg(cc), dest: label | if ($cond\equiv le$) goto $dest$ \cr
bnl | branch if not less || cond: preg(cc), dest: label | if ($cond\equiv ge$) goto $dest$\cr
bne | branch if not equal ||  cond: preg(cc), dest: label | if ($cond\equiv ne$) goto $dest$\cr

iba | indirect branch always (jump) || dest: preg(l) | goto $dest$\cr
ibn | indirect branch never (nop) || dest: preg(l) | no operation\cr
ibm | indirect branch multiple (switch jump) | t | val:preg(t), lvl preg(l)-val-list(t) | j $lvl [val]$ \cr
ibg | indirect branch if greater || cond: preg(cc), dest: preg(l) | if ($cond\equiv gt$) goto $dest$\cr
ibl | indirect branch if less || cond: preg(cc), dest: preg(l) | if ($cond\equiv lt$) goto $dest$ \cr
ibe | indirect branch if equal || cond: preg(cc), dest: preg(l) | if ($cond\equiv eq$) goto $dest$\cr
ibng | indirect branch if not greater || cond: preg(cc), dest: preg(l) | if ($cond\equiv le$) goto $dest$ \cr
ibnl | indirect branch if not less || cond: preg(cc), dest: preg(l) | if ($cond\equiv ge$) goto $dest$\cr
ibne | indirect branch if not equal ||  cond: preg(cc), dest: preg(l) | if ($cond\equiv ne$) goto $dest$

\endtable
\null\vfill
\begintable
mnemonics | full name | types | format | note -- functional description \cr
Conditional Data Flow\cr
sbg | set true if greater | t | result: preg(bool), src1: preg(t), src2: preg(t) | $result$ gets ($src1 > src2$)\cr
sbl | set true if less | t | result: preg(bool), src1: preg(t), src2: preg(t) | $result$ gets ($src1 < src2$)\cr
sbe | set true if equal | t | result: preg(bool), src1: preg(t), src2: preg(t) | $result$ gets ($src1 == src2$)\cr
sbng | set true if not greater | t | result: preg(bool), src1: preg(t), src2: preg(t) | $result$ gets ($src1 <= src2$)\cr
sbnl | set true if not less | t | result: preg(bool), src1: preg(t), src2: preg(t) | $result$ gets ($src2 >= src1$)\cr
sbne | set true if not equal | t | result: preg(bool), src1: preg(t), src2: preg(t) | $result$ gets ($src1 != src2$) 

\endtable
\bye

